feldspar-language-0.6.0.2: A functional embedded language for DSP and parallelism

Safe Haskell | None

Feldspar.Core.Constructs.Logic

Description

Implementation of Logic constructs

Synopsis

- data Logic a where
  - And :: Logic (Bool :-> (Bool :-> Full Bool))
  - Or :: Logic (Bool :-> (Bool :-> Full Bool))
  - Not :: Logic (Bool :-> Full Bool)

# Documentation

data Logic a where

Logic constructs

Constructors

And :: Logic (Bool :-> (Bool :-> Full Bool)) |
Or :: Logic (Bool :-> (Bool :-> Full Bool)) |
Not :: Logic (Bool :-> Full Bool) |

Instances

EvalBind Logic |
Semantic Logic |
Eval Logic |
Render Logic |
ToTree Logic |
Equality Logic |
Sharable Logic |
AlphaEq dom dom dom env => AlphaEq Logic Logic dom env |
SizeProp (:|| Logic Type) |
(:<: (:|| Logic Type) dom, :<: (:|| EQ Type) dom, :<: (:|| ORD Type) dom, OptimizeSuper dom) => Optimize (:|| Logic Type) dom |